<?php
function getEncryptionKey() {
    // Replace this with your actual key retrieval logic
    return "your_16_byte_key_";  // Example key (16 bytes)
}

// Function to perform encryption
function encryptData($data) {
    $key = getEncryptionKey();  // Retrieve the encryption key
    $iv = "1234567890123456";  // Static IV (16 bytes for AES-128-CBC)

    // Encrypt the data using AES-128-CBC
    $encrypted = openssl_encrypt($data, "AES-128-CBC", $key, OPENSSL_RAW_DATA, $iv);
    if ($encrypted === false) {
        throw new Exception('Encryption failed.');
    }
    return bin2hex($encrypted);  // Convert the encrypted data to hexadecimal
}

$live_id = $_GET['id'] ?? '';

if (!$live_id) {
    die("Error: 'id' parameter is required.");
}

// Fetch the YouTube live page
$m3u8_page = reqGet("https://www.youtube.com/{$live_id}/live", []);

if (!$m3u8_page) {
    die("Error: Unable to fetch YouTube live page.");
}

// Extract the HLS manifest URL
$pattern = '/(?<="hlsManifestUrl":").*?\.m3u8/';
preg_match($pattern, $m3u8_page, $matches);

if (!empty($matches[0])) {
    $hls_manifest_url = $matches[0];

    // Fetch the original M3U8 content
    $stream = reqGet($hls_manifest_url, []);
    if (!$stream) {
        die("Error: Unable to fetch the HLS manifest content.");
    }

$lines = explode("\n", $stream);
        $output = '';

        foreach ($lines as $line) {
            if (strpos($line, '#EXTINF') === 0) {
                // Append the EXTINF line to the output
                $output .= $line . "\n";
            } elseif (!empty($line) && strpos($line, '#') === false) {
                // Encrypt the segment URL
                $encryptedSegment = encryptData($line);
                // Replace the segment URL with the encrypted value and vtoken
                $output .= "ts.php?hex=$encryptedSegment&vai=$id\n";
            } else {
                // Append other lines (like #EXTM3U, #EXT-X-*) without modification
                $output .= $line . "\n";
            }
        }
        
        echo $output;
    }
// Helper function to fetch data
function reqGet($url, $header) {
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 10,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => $header,
    ));
    $data = curl_exec($curl);
    if (curl_errno($curl)) {
        error_log("cURL error: " . curl_error($curl));
    }
    curl_close($curl);
    return $data;
}
?>
