<?php

// Function to retrieve the encryption key
function getEncryptionKey() {
    return "your_16_byte_key_";  // Example key (16 bytes, AES-128 requires this length)
}

// Function to decrypt data
function decryptData($data) {
    $key = getEncryptionKey();
    $iv = "1234567890123456";  // Static IV (16 bytes)

    // Convert from hexadecimal to binary
    $binaryData = hex2bin($data);
    if ($binaryData === false) {
        throw new Exception('Invalid hexadecimal data.');
    }

    // Perform decryption
    $decryptedData = openssl_decrypt($binaryData, "AES-128-CBC", $key, OPENSSL_RAW_DATA, $iv);
    if ($decryptedData === false) {
        throw new Exception('Decryption failed.');
    }

    return $decryptedData;
}

// Function to encrypt data
function encryptData($data) {
    $key = getEncryptionKey();
    $iv = "1234567890123456";  // Static IV (16 bytes)

    // Perform encryption
    $encryptedData = openssl_encrypt($data, "AES-128-CBC", $key, OPENSSL_RAW_DATA, $iv);
    if ($encryptedData === false) {
        throw new Exception('Encryption failed.');
    }

    return bin2hex($encryptedData);  // Convert encrypted data to hexadecimal
}

// Get the 'segment' and 'vtoken' parameters from the URL
$segment = $_GET['hex'] ?? null;
$vtoken = $_GET['vai'] ?? null;

if ($segment === null || $vtoken === null) {
    die("Error: Missing segment or vtoken.");
}

// Decrypt the segment data
try {
    $decryptedData = decryptData($segment);
} catch (Exception $e) {
    die("Decryption error: " . $e->getMessage());
}

// Fetch the M3U8 content from the decrypted segment URL
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $decryptedData);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, ["Referer: "]);  // Add headers if required
$response = curl_exec($ch);
if (curl_errno($ch)) {
    die("Error: Unable to fetch the M3U8 content.");
}
curl_close($ch);

// Process the M3U8 content
$lines = explode("\n", $response);
$output = '';

foreach ($lines as $line) {
    if (strpos($line, '#EXTINF') === 0) {
        // Keep EXTINF lines as-is
        $output .= $line . "\n";
    } elseif (!empty($line) && strpos($line, '#') === false) {
        // Encrypt segment URLs
        try {
            $encryptedSegment = encryptData($line);
            $output .= "hex.php?hex=$encryptedSegment&vai=$vtoken\n";
        } catch (Exception $e) {
            die("Error: Unable to encrypt segment URL.");
        }
    } else {
        // Keep other lines unchanged
        $output .= $line . "\n";
    }
}
echo $output;

?>
